# ------------------------------------------------------------------------------
#  ATV XBMC Plugin, -> very spezial Thanx to chmee phreekz for RTL Now Template
#
# (c) by djtulan 2012
# ------------------------------------------------------------------------------
import xbmcplugin
import xbmcgui
import sys
import urllib, urllib2
import re
from htmlentitydefs import name2codepoint as n2cp

# ------------------------------------------------------------------------------
# object
# ------------------------------------------------------------------------------
thisPlugin = int(sys.argv[1])

# ------------------------------------------------------------------------------
# HOST url
# ------------------------------------------------------------------------------
urlHost = "http://atv.at"

# ------------------------------------------------------------------------------
# zuerst das DIV auslesen
regexContentDIV = '<div class="missed float_left">(.*?)</div>'
# [0] content of div tag "missed"
# ------------------------------------------------------------------------------
# dann die liste erzeugen (inclusive icon)
regexContent = '<li>.*?<a title="(.*?)" href="(.*?)">.*?<img alt=".*?" src="(.*?)" />.*?</a>.*?</li>'
# [0] name
# [1] is url
# [2] icon
# ------------------------------------------------------------------------------
# RSS of series auswerten
regexSeries = '<item>.*?<guid>(.*?)</guid>.*?<title>(.*?)</title>.*?</item>'
# [0] guid
# [1] title
# ------------------------------------------------------------------------------
# remove CDATA strings
regexXML = '<!\[CDATA\[(.*?)\]\]>'
# [0] simple content inside CDATA Tag
# ------------------------------------------------------------------------------
# get last number from content url
regexID = '.*?contentset\/[0-9]+\/([0-9]+)'
# [0] last number
# ------------------------------------------------------------------------------
# get stream ids
regexVideoData = '"video":([0-9]+)'
regexStreamData = '"streaming_ids":\[(.*?)\]' 
# [0] string including stream ids
# ------------------------------------------------------------------------------




# ------------------------
# gesamten Inhalt anzeigen
# ------------------------
def showContent():
	global thisPlugin

	print "ATV::showContent"
	content = getUrl(urlHost)
	
	divtag = re.compile(regexContentDIV,re.DOTALL).findall(content)

	for d in divtag:
		match = re.compile(regexContent,re.DOTALL).findall(d)
		
		for m in match:
			addDirectoryItem(m[0].strip(), {"urlS": m[1]}, urlHost+m[2])  

	print "--- showContent ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

# ------------------------
# einzelne Serien anzeigen
# ------------------------
def showSeries(urlS):
	global thisPlugin

	print "ATV::showSeries -> " + urlS
	content = getUrl(urlS)
	
	match = re.compile(regexSeries,re.DOTALL).findall(content)

	oldtitle = ''
	oldurl = ''
	
	for m in match:		
		# remove CDATA
		t = re.compile(regexXML,re.DOTALL).findall(m[1])
		u = re.compile(regexXML,re.DOTALL).findall(m[0])
		title = t[0]
		url = u[0]

		#  prevent from duplicate items (fucking RSS Feed !!!)
		if title != oldtitle or url!= oldurl:
			
			# get ID from complete url
			info = re.compile(regexID).findall(url)
			id = info[0]
			
			# calc icon
			icon = urlHost + "/binaries/asset/tvnext_clip/" + id + "/player_image"
			
			# add to directory
			addDirectoryItem(title, {"urlV": id}, icon)
		
		oldtitle = title
		oldurl = url
	
	print "--- showSeries ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

# ------------------------
# video abspielen
# ------------------------
def showVideo(urlV):
	global thisPlugin

	print "ATV::showVideo -> " + urlV	
	id = urlV
	
	# get clip content as JSON data string
	getclipurl = urlHost + "/getclip/" + id	
	content = getUrl(getclipurl)

	result = re.compile(regexStreamData, re.DOTALL).findall(content)
	
	if result:
		
		# get list of sreaming id
		list = result[0].split(",")

		pl = xbmc.PlayList(xbmc.PLAYLIST_VIDEO)
		pl.clear()
		counter = 0

		for l in list:
			# try both streaming urls
			videoUrl1 = 'rtmp://cp112898.edgefcs.net/ondemand/mp4:' + l
			videoUrl2 = 'rtmp://cp112899.edgefcs.net/ondemand/mp4:' + l

			item1 = xbmcgui.ListItem(videoUrl1)
			item1.setInfo('video', {'Title': 'video1', 'Genre': 'ATV'})
			item2 = xbmcgui.ListItem(videoUrl2)
			item1.setInfo('video', {'Title': 'video2', 'Genre': 'ATV'})
			# print "============================================="
			# print videoUrl1
			# print videoUrl2
			# print "============================================="
			# add items to playlist
			pl.add(videoUrl1, item1)
			pl.add(videoUrl2, item2)
		
		#play Playlist
		xbmc.Player(xbmc.PLAYER_CORE_DVDPLAYER).play(pl)
	
	print "--- showVideo ok"	


# ------------------------
# get content of URL
# ------------------------
def getUrl(url):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
    return link

# ------------------------
# add Item to Directory
# params name, parameter, pic
# ------------------------
def addDirectoryItem(name, parameters={}, pic=""):
    li = xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=pic)
    url = sys.argv[0] + '?' + urllib.urlencode(parameters)
    return xbmcplugin.addDirectoryItem(handle = int(sys.argv[1]), url=url, listitem=li, isFolder=True)

# ------------------------
# Convert parameters encoded in a URL to a dict.
# ------------------------
def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

# ------------------------
def substitute_entity(match):
    ent = match.group(3)
    
    if match.group(1) == "#":
        if match.group(2) == '':
            return unichr(int(ent))
        elif match.group(2) == 'x':
            return unichr(int('0x'+ent, 16))
    else:
        cp = n2cp.get(ent)

        if cp:
            return unichr(cp)
        else:
            return match.group()

# ------------------------
def decode_htmlentities(string):
    entity_re = re.compile(r'&(#?)(x?)(\w+);')
    return entity_re.subn(substitute_entity, string)[0]




# ------------------------
#  MAIN
# ------------------------
params = parameters_string_to_dict(sys.argv[2])
urlSeries = str(params.get("urlS", ""))
urlVideo = str(params.get("urlV", ""))

# wenn kein Parameter
if not sys.argv[2]:
	# show content
	ok = showContent()
else:
	# show list of series
	if urlSeries:
		# print urllib.unquote(urlSeries)
		newUrl = urlHost + "/feed" + urllib.unquote(urlSeries)  #calculate serien rss url
		# print newUrl
		ok = showSeries(newUrl)
	# play video
	if urlVideo:
		newUrl = decode_htmlentities(urllib.unquote(urlVideo))
		# print newUrl
		ok = showVideo(newUrl)
